#!/bin/bash

# ****************************************************************************************************************** #

# openEuler23.03-GUI-install.sh
# 测试ISO : openEuler-23.03-everything-x86_64-dvd.iso
# 其他iso也可以

# 注：适用于第一次安装图形界面GUI
# scp -P 22 xx@IP:openEuler23.03-GUI-install.sh  ~

# dvd-everything里面没有linghtdm和xfce4,需要联网安装

# 注：23.03有一个openeuler管理员用户,可删除,22.03则没有
# https://docs.openeuler.org/zh/docs/23.03/docs/desktop/Install_XFCE.html  安装指南

# 测试可用：openEuler22.03-LTS
# 测试可用：openEuler22.03-LTS-sp1
# 测试可用：openEuler22.09
# 测试可用：openEuler23.03

#  /etc/fonts/fonts.conf 多次执行，要查看是否有多余内容

# ****************************************************************************************************************** #

echo "**************************************************"
echo -e "\e[1;32m    openEuler Install GUI !      \e[0m"
echo "**************************************************"
echo ""
echo -e "---------------- Execution -----------------"
echo -e "\e[1;33m 1.Can you access the network , if not try modifying /etc/resolv.conf ! \e[0m"
echo -e "\e[1;32m   e.g. : ping mirrors.ustc.edu.cn       \e[0m\n"

echo -e "\e[1;33m 2-1.Add CD/ISO source ! \e[0m"
echo -e "\e[1;32m   mkdir -p /media/cdrom && mount /dev/sr0 /media/cdrom \e[0m"
echo -e "\e[1;32m   lsblk \n"

echo -e "\e[1;33m 2-2.If CD is Ventory,please execute the following commands ! \e[0m"
echo -e "\e[1;32m   mkdir -p /media/disk &&  mount /dev/sdx  /media/disk  \e[0m"
echo -e "\e[1;32m   mkdir -p /media/cdrom && mount /media/disk/xx.iso /media/cdrom  \e[0m\n"

echo -e "\e[1;33m 3.Finally execute the script ! \e[0m\n"

echo "**************************************************"

read -p "Press <Enter> to continue ..." < /dev/tty

# 等同于 date +"%F %T"
firsttime=`date +"%Y-%m-%d %H:%M:%S"`

if [ $UID != "0" ]; then
   echo "Not Root!!! Please exit, and login as root again!"
   exit
fi

# 自定义用户
echo -e "\nHomeDir:/home"
ls -l /home | tail -n +2 | grep -iE -v "lost\+found"
echo ""

read -p "Enter Normal-User: " User_Owner

# 先关闭SELINUX，防止重启后出现“Failed to load SELinux policy. Freezing”错误 导致一直不能启动
sed -e 's/SELINUX=enforcing/SELINUX=permissive/' -i /etc/selinux/config

#-------------------------------------------------------------------------------------------------------------#
# 选择版本

echo -e "\n\e[1;36m===========================================================\e[0m" 
#openEulerName=`cat /etc/os-release | grep -w NAME | cut -d "\"" -f2`
#openEulerVersion=`cat /etc/os-release | grep -w VERSION | cut -d "\"" -f2`
#openEuler_release="${openEulerName}-${openEulerVersion}"
basearch=`uname -m`

oerel=`cat /etc/os-release | grep -w PRETTY_NAME | cut -d "\"" -f2`
echo -e "\n\e[1;35mopenEuler release messages : ${oerel} \e[0m\n"

echo -e "\e[1;34mNote: Be sure to select the exact option below \e[0m"
echo " 1.OS Release : openEuler-22.03-LTS     "
echo " 2.OS Release : openEuler-22.03-LTS-SP1 "
echo " 3.OS Release : openEuler-22.03-LTS-SP2 [Not yet, don't choose]"
echo " 4.OS Release : openEuler-22.03-LTS-SP3 [Not yet, don't choose]"
echo " 5.OS Release : openEuler-22.09         "
echo " 6.OS Release : openEuler-23.03         "
echo "  other       : Wrong version, exit install "

echo ""
read -p "Please Select OS Release: " os_release
case ${os_release} in 
    "1")
    echo "openEuler os_release : openEuler-22.03-LTS "
    openEuler_release="openEuler-22.03-LTS"
    ;;
    "2")
    echo "openEuler os_release : openEuler-22.03-LTS-SP1 "
    openEuler_release="openEuler-22.03-LTS-SP1"
    ;;
    "3")
    echo "openEuler os_release : openEuler-22.03-LTS-SP2 [Not yet, don't choose]"
    #openEuler_release="openEuler-22.03-LTS-SP2"
    echo "Not yet, don't choose, exit install"
    exit
    ;;
    "4")
    echo "openEuler os_release : openEuler-22.03-LTS-SP3 [Not yet, don't choose]"
    #openEuler_release="openEuler-22.03-LTS-SP3"
    echo "Not yet, don't choose, exit install"
    exit
    ;;
    "5")
    echo "openEuler os_release : openEuler-22.09 "
    openEuler_release="openEuler-22.09"
     ;;
     "6")
    echo "openEuler os_release : openEuler-23.03 "
    openEuler_release="openEuler-23.03"
     ;;
    *)
    echo "Wrong version, exit install"
    exit 
    ;;
esac

echo -e "\e[1;36m===========================================================\e[0m\n" 

#-------------------------------------------------------------------------------------------------------------#
# 显示器分辨率
#-------------------------------------------------------------------------------------------------------------#
resolution="1280x800"
echo " 1.Screen Resolutions :  1024x768 (VBox+MBR)"
echo " 2.Screen Resolutions :  800x1280 (MiniBook)"
echo " 3.Screen Resolutions :  1280x720 [16:9](MicroPC)"
echo " 4.Screen Resolutions :  1366x768 [16:9]"
echo " 5.Screen Resolutions :  1440x900 [16:10]"
echo " 6.Screen Resolutions :  1600x900 [16:9]"
echo " 7.Screen Resolutions : 1920x1080 [16:9 FHD]"
echo " 8.Screen Resolutions : 2560x1600 [16:10]"
echo " 9.Screen Resolutions : 2560x1440 [16:9 QHD]"
echo "10.Screen Resolutions : 3840x2160 [16:9 UHD]"
echo "other : Screen Resolutions : ${resolution} (Default)"

echo ""
read -p "Please Slelect Screen Resolutions: " choice
case $choice in 
    "1")
    echo "Screen Resolutions(VBox+MBR) : 1024x768"
    resolution="1024x768"
    ;;
    "2")
    echo "Screen Resolutions (MiniBook) : 800x1280"
    resolution="800x1280"
    ;;
    "3")
    echo "Screen Resolutions : 1280x720 [16:9] (MicroPC)"
    resolution="1280x720"
    ;;
    "4")
    echo "Screen Resolutions : 1366x768 [16:9]"
    resolution="1366x768"
    ;;
    "5")
    echo "Screen Resolutions : 1440x900 [16:10]"
    resolution="1440x900"
    ;;
    "6")
    echo "Screen Resolutions : 1600x900 [16:9]"
    resolution="1600x900"
    ;;
    "7")
    echo "Screen Resolutions : 1920x1080 [16:9 FHD]"
    resolution="1920x1080"
    ;;
    "8")
    echo "Screen Resolutions : 2560x1600 [16:10]"
    resolution="2560x1600"
    ;;
    "9")
    echo "Screen Resolutions : 2560x1440 [16:9 QHD]"
    resolution="2560x1440"
    ;;
    "10")
    echo "Screen Resolutions : 3840×2160 [16:9 UHD]"
    resolution="3840x2160"
    ;;
    *)
    echo "Other Screen Resolutions, Use default:${resolution}"
    ;;
esac


# ------------------------------------------------------------------ #
#                         更新源
# ------------------------------------------------------------------ #

# 选择最快的源
# 中科大         https://mirrors.ustc.edu.cn
# 清华源         https://mirrors.tuna.tsinghua.edu.cn              
# 南大源         https://mirrors.nju.edu.cn         
# 上海交大源     https://mirror.sjtu.edu.cn  
# 华为源[默认]   https://mirrors.huaweicloud.com  

# ping源
url0="https://mirrors.huaweicloud.com"
url1="https://mirrors.tuna.tsinghua.edu.cn"
url2="https://mirrors.nju.edu.cn"
url3="https://mirror.sjtu.edu.cn"
url4="https://mirrors.ustc.edu.cn"

lists="${url0} ${url1} ${url2} ${url3} ${url4}"

echo ""
echo -e "\e[1;36m===========================================================\e[0m" 
for mirror in ${lists}
do 
  echo -e "\e[1;32m [${mirror}] \e[0m"
  ping $(echo ${mirror} | cut -d'/' -f3) -c2 | head -n2 | tail -n1 | cut -d ":" -f2 
  echo ""
done


mirrorlist="${url0}"
echo -e "\e[1;34m===========================================================\e[0m" 
echo -e "\e[1;35m Some Mirrors! Please select it! \e[0m"

echo -e "\e[1;32m ${url0} [default] \e[0m\n"    
     
echo -e "\e[1;32m 0.${url0} \e[0m"   
echo -e "\e[1;32m 1.${url1} \e[0m"     
echo -e "\e[1;32m 2.${url2} \e[0m"    
echo -e "\e[1;32m 3.${url3} \e[0m"       
echo -e "\e[1;32m 4.${url4} \e[0m"  

# 下面的也可以
# i=1
# for url in ${lists}
# do 
#   echo -e "\e[1;32m ${i}.${url} \e[0m"
#   let i++
# done
echo -e "\e[1;34m===========================================================\e[0m" 

read -p "Please Select Mirror: " number
case $number in 
    "1")
    echo -e "\e[1;32m [${url1}] \e[0m"
    mirrorlist="${url1}"
    ;;
    "2")
    echo -e "\e[1;32m [${url2}] \e[0m"
    mirrorlist="${url2}"
    ;;
    "3")
    echo -e "\e[1;32m [${url3}] \e[0m"
    mirrorlist="${url3}"
    ;;
    "4")
    echo -e "\e[1;32m [${url4}] \e[0m"
    mirrorlist="${url4}"
    ;;
    *)
    echo -e "\e[1;33m Other mirror, Use default mirror: \e[0m" 
    echo -e "\e[1;32m [${mirrorlist}] \e[0m" 
    ;;
esac

sourceslist="/etc/yum.repos.d/openEuler.repo"
[ -f ${sourceslist}.bak ] && cp  ${sourceslist}.bak ${sourceslist} || cp  ${sourceslist} ${sourceslist}.bak


# 更换完整更新源buster (注：EOF不加“”则读取值 ，加""则为字符串)
cat << EOF > /etc/yum.repos.d/openEuler.repo
# 设置repo优先级，priority=2,仅次于dvd源，默认99,最低级，最高1
# os基础软件包源
[OS]
name=OS
baseurl=${mirrorlist}/openeuler/$openEuler_release/OS/$basearch/
enabled=1
priority=2
gpgcheck=1
gpgkey=${mirrorlist}/openeuler/$openEuler_release/OS/$basearch/RPM-GPG-KEY-openEuler

# everything 全量软件包源
[everything]
name=everything
baseurl=${mirrorlist}/openeuler/$openEuler_release/everything/$basearch/
enabled=1
priority=2
gpgcheck=1
gpgkey=${mirrorlist}/openeuler/$openEuler_release/everything/$basearch/RPM-GPG-KEY-openEuler

# debuginfo 调试包源
[debuginfo]
name=debuginfo
baseurl=${mirrorlist}/openeuler/$openEuler_release/debuginfo/$basearch/
enabled=1
priority=2
gpgcheck=1
gpgkey=${mirrorlist}/openeuler/$openEuler_release/debuginfo/$basearch/RPM-GPG-KEY-openEuler

# source 软件包源
[source]
name=source
baseurl=${mirrorlist}/openeuler/$openEuler_release/source/
enabled=1
priority=2
gpgcheck=1
gpgkey=${mirrorlist}/openeuler/$openEuler_release/source/RPM-GPG-KEY-openEuler


# EPOL openEuler扩展包(gpgkey和OS一样)
[EPOL]
name=EPOL
baseurl=${mirrorlist}/openeuler/$openEuler_release/EPOL/main/$basearch/
enabled=1
priority=2
gpgcheck=1
gpgkey=${mirrorlist}/openeuler/$openEuler_release/OS/$basearch/RPM-GPG-KEY-openEuler

# update 升级软件包源(gpgkey和OS一样)
[update]
name=update
baseurl=${mirrorlist}/openeuler/$openEuler_release/update/$basearch/
enabled=1
priority=2
gpgcheck=1
gpgkey=${mirrorlist}/openeuler/$openEuler_release/OS/$basearch/RPM-GPG-KEY-openEuler
EOF


# 更新缓存
#dnf clean all && dnf makecache

# ------------------------------------------------------------------ # 
#      加dvd仓库,没有linghtdm和xfce4
# ------------------------------------------------------------------ # 

# 查看系统加载的本地仓库：
#dnf repolist
#mkdir -pv /media/cdrom

cat > /etc/yum.repos.d/openEuler_cdrom.repo << EOF
[openEuler_cdrom]
name=openEuler_cdrom
baseurl=file:///media/cdrom
enabled=1
# 优先使用dvd的源
priority=1
gpgcheck=1
gpgkey=file:///media/cdrom/RPM-GPG-KEY-openEuler
EOF

# 使本地仓库生效
dnf clean all && dnf makecache

# 查看系统加载的本地仓库：
dnf repolist all && sleep 6


# ------------------------------------------------------------------
dnf install -y dirmngr
dnf install -y nano lftp 
dnf install -y bash-devel bash-completion bash-completion-help 

# 修改grub
dnf install -y grub2
defaultgrub="/etc/default/grub"
[ -f ${defaultgrub}.bak ] && cp ${defaultgrub}.bak ${defaultgrub} || cp ${defaultgrub} ${defaultgrub}.bak

sed 's/GRUB_GFXMODE/#GRUB_GFXMODE/g' -i /etc/default/grub
echo "GRUB_GFXMODE=${resolution}" >> /etc/default/grub
#grub-mkconfig -o /boot/grub/grub.cfg 

# ---------------------------------基本配置--------------------------------- #
# 编译相关环境设置
ldconf="/etc/ld.so.conf"
[ -f ${ldconf}.bak ] && cp ${ldconf}.bak ${ldconf} || cp ${ldconf} ${ldconf}.bak

cat << EOF > /etc/ld.so.conf
include /etc/ld.so.conf.d/*.conf
include /lib
include /lib64

include /usr/lib
include /usr/lib64
include /usr/libexec

include /usr/local/lib
include /usr/local/lib64

include /usr/lib/gcc/x86_64-linux-gnu/
include /usr/libexec/gcc/x86_64-linux-gnu/
EOF

/sbin/ldconfig

echo "export PKG_CONFIG_PATH=/usr/local/lib/pkgconfig:/usr/lib/pkgconfig:/lib/pkgconfig" >> /etc/profile
source /etc/profile


# 安装编译环境
dnf install -y kernel kernel-devel dkms
dnf install -y gcc-c++ gcc-objc++  
dnf install -y make cmake automake autoconf intltool  
dnf install -y build rpm-build rpmdevtools bzip2
dnf install -y bash-completion
dnf install -y gnutls-utils CUnit autogen symlinks fmt GConf2


# python相关
dnf install -y python3-devel python3-pkgconfig
dnf install -y python3-pip python3-lxml python3-keyring 

# 会替换openssh-server openssh-client
dnf install -y libnotify libnotify-devel

dnf install -y perl ruby

# gtk相关
dnf install -y gtk2 gtk2-devel  gtk-doc gtk2-help
dnf install -y gtk3-devel
dnf install -y gtkmm30

dnf install -y wxGTK3-devel compat-wxGTK3-gtk2-devel


# 安装go语言
# 查看go版本 go version  && go env
dnf install -y golang

# 安装 Rust语言及其 Cargo 软件包管理器
dnf install -y rustc cargo 

# 其他文件系统支持
dnf install -y gvfs gvfs-devel ntfs-3g ntfs-3g-devel
dnf install -y xfsprogs xfsdump jfsutils btrfs-progs dosfstools mtools 
dnf install -y fuse fuse-devel fuse3 fuse3-devel

# dnf命令(已安装)
dnf install -y dnf dnf-plugins-core python3-dnf python3-dnf-plugins-core
dnf install -y python3-dnf-plugin-leaves python3-dnf-plugin-show-leaves etckeeper-dnf
dnf install -y PackageKit-yum  PackageKit-yum-plugin 
dnf install -y expect

# 新建本地源, createrepo --database /mnt/local_repo (本地软件源仓库目录)
dnf install -y createrepo

# 保留安装包(默认删除),配置/etc/dnf/dnf.conf(可选),使用时，反注释即可
# 清理软件包 dnf clean packages
cp -f /etc/dnf/dnf.conf /etc/dnf/dnf.conf.bak
echo "#keepcache=1" >> /etc/dnf/dnf.conf

# x11相关
dnf install -y Xorg 
dnf install -y xinit xorg-x11-xinit xorg-x11-utils 
dnf install -y xorg-x11-server-utils xorg-x11-server-Xvfb
dnf install -y xorg-x11-drv-{fbdev,vesa,intel} 


# 其他桌面(选用)
#dnf install -y mate-desktop   #安装最少，登陆界面没有选项
#dnf install -y kiran-desktop  #和mate类似，下载164M
#dnf install -y ukui           #选择不安装,不喜欢，下载463M
#dnf install -y dde            #选择不安装,太卡，下载503M
#dnf install -y cinnamon      # 下载184M
#dnf install -y lxde lxqt     # 暂时还没有

# xfce4桌面
dnf install -y xfce4* 
# 可能是network-manager-applet含有gnome桌面，删除gnome-desktop3，不使用
#dnf install -y xfwm4 xfdesktop xfce4-* xfce4-*-plugin network-manager-applet 
dnf install -y xfce-theme-manager


# 或者试用自定义桌面 
#dnf install -y openbox openbox-devel openbox-help openbox-kde

# ---------------------------------安装软件--------------------------------- #

# 安装驱动
dnf install -y linux-firmware linux-firmware-iwlwifi alsa-firmware crystalhd-firmware 

# gconf-editor
dnf install -y dconf-editor 

# 网络管理图形工具
dnf install -y wireless-tools net-tools
dnf install -y NetworkManager network-manager-applet　
systemctl enable NetworkManager


# 安装主题：/usr/share/themes/或者~/.themes
dnf install -y adwaita-icon-theme 
dnf install -y adwaita-qt adwaita-qt-devel
dnf install -y gnome-icon-theme breeze-icon-theme deepin-icon-theme 
dnf install -y gnome-themes-standard  breeze-cursor-theme 

# ------------------------------------------安装输入法-----------------------------------------
# 安装中文字体，避免出现方块字
dnf groupinstall -y "fonts"
dnf install -y wqy*
dnf install -y cjkuni-ukai-fonts gnu-free-sans-fonts
dnf install -y fonttools
# 简体中文繁体转换库
dnf install -y opencc

# 输入法ibus
#dnf install -y ibus ibus-devel 
#dnf install -y ibus-m17n ibus-libpinyin ibus-table-chinese ibus-table-chinese-yong 

# 输入法fcitx
dnf install -y fcitx fcitx-devel 
dnf install -y fcitx-cloudpinyin fcitx-sunpinyin fcitx-libs fcitx-configtool
dnf install -y libpinyin-devel sunpinyin-devel

dnf install -y gtk2-immodule-xim
# 选择fcitx
#update-alternatives --config xinputrc
imsettings-switch fcitx
cat << EOF >> /etc/profile
export GTK_IM_MODULE=fcitx
export QT_IM_MODULE=fcitx
export XMODIFIERS="@im=fcitx"
EOF


# ------------------------------------------------------------------ #
#                     安装网络工具
# ------------------------------------------------------------------ #
dnf install -y firefox 
dnf install -y epiphany

dnf install -y lftp vsftpd
 

# linux光盘刻录软件：
dnf install -y brasero xfburn  

# 文本界面的网页浏览器
dnf install -y elinks links


# 网络测试软件合集
dnf install -y nethogs  nmap  
dnf install -y iftop  iptraf nmon dstat saidar 
dnf install -y htop iotop  
dnf install -y logwatch quota 

dnf install -y dpkg dpkg-devel


# 防火墙
dnf install -y firewalld firewall-config
systemctl enable firewalld

# Error: COMMAND_FAILED: '/usr/sbin/ip6tables-restore -w -n' failed: ip6tables-restore v1.8.2 (nf_tables):
# 解决办法：不要使用-restore组合呼叫，而要使用单个呼叫
sed 's|IndividualCalls=no|IndividualCalls=yes|g' -i /etc/firewalld/firewalld.conf

systemctl start firewalld

firewall-cmd --set-default-zone=public
# 端口20018给ssh测试用，可以修改
firewall-cmd --permanent --zone=public --add-port=20018/tcp
firewall-cmd --permanent --zone=public --add-service=ssh
firewall-cmd --permanent --zone=public --add-service=http
firewall-cmd --permanent --zone=public --add-service=https
firewall-cmd --permanent --zone=public --add-service=vnc-server
firewall-cmd --permanent --zone=public --add-service=mysql
firewall-cmd --permanent --zone=public --add-service=postgresql
#firewall-cmd --permanent --zone=public --add-service=dhcp
#firewall-cmd --permanent --zone=public --add-service=dns
#firewall-cmd --permanent --zone=public --add-service=finger
firewall-cmd --permanent --zone=public --add-service=ntp
#firewall-cmd --permanent --remove-service=dns
#firewall-cmd --reload 
systemctl restart firewalld


# ------------------------------------------------------------------ #
#                    安装音频/视频
# ------------------------------------------------------------------ #
# 安装音频/视频:
dnf install -y alsa-utils alsa-tools pavucontrol 

dnf install -y gstreamer1 gstreamer1-devel  
dnf install -y gstreamer1-plugins-base gstreamer1-plugins-base-devel  
dnf install -y gstreamer1-plugins-good gstreamer1-plugins-good-gtk
dnf install -y gstreamer1-plugins-bad-free

dnf install -y x264 x264-devel x265 x265-devel
dnf install -y mpeg2dec mpg123 lame-devel

# Crystal HD Video Decoder 
dnf install -y libcrystalhd libcrystalhd-devel 

dnf install -y mpv ffmpeg
# mpv配置
mpvconf="/etc/mpv/mpv.conf"
[ ! -f ${mpvconf} ] && touch ${mpvconf}
[ -f ${mpvconf}.bak ] && cp ${mpvconf}.bak ${mpvconf} || cp ${mpvconf} ${mpvconf}.bak

cat >> /etc/mpv/mpv.conf << "EOF"
[mympv-gui]
# 终端=否
terminal=no
# 空闲=1次
idle=once
# 强制窗口=是
force-window=yes
# 限制窗口大小
geometry=90%x82%
#geometry=683x384
# 多长时间隐藏鼠标
#cursor-autohide=5

# 指定要使用的视频输出后端,默认使用GPU加速的视频输出
#vo=gpu
# 使用解码器（默认 no），软解码（no），硬解码（yes）[no,yes,auto]，避免使用硬件解码
hwdec=auto
# 顺时针旋转视频，以度为单位。<0-359 |否>
video-rotate=0
# 调整视频显示比例。不缩放:0，两倍:1，二分之一:-1，依此类推
video-zoom=0


# 默认选中中文字幕
# 指定要使用的字幕语言的优先级列表
slang=zh-CN,chi,sc,chs
# 指定要使用的音频语言的优先级列表
alang=zh-CN,chi,sc,chs
# 相当于--alang和--slang，用于视频轨道
vlang=zh-CN,chi,sc,chs

#将非utf8编码的字幕转换成utf8，解决所有乱码问题，依赖enca
#sub-codepage=zh_CN.UTF-8,zh_CN.GB18030,iso8859-1
sub-codepage=enca:zh:utf8,iso8859-1


# 会在播放音频文件时显示图像附件（例如专辑封面）（默认）,no 在播放音频文件时完全禁用视频显示,对具有正常视频轨道的文件没有影响
audio-display=no

# osd相关
osd-bar=
# osd level级别
# 0:OSD完全禁用（仅字幕）
# 1:启用（仅在用户交互时显示）
# 2:默认启用2个+当前时间
# 3:启用+ --osd-status-msg（默认为当前时间和状态）
osd-level=3
osd-msg3=
# 设置搜索期间OSD上显示的内容。默认值为bar <no，bar，msg，msg-bar>
#osd-on-seek=bar

#显示OSD时间（以秒为单位）（以毫秒为单位）。 有助于查看视频帧的确切时间戳，需要配合osd-level=3使用
osd-fractions=
# 以毫秒为单位设置OSD消息的持续时间（默认值：1000）
#osd-duration=
# 指定用于OSD的字体。缺省值为sans-serif
osd-font='sans-serif'
osd-font-size=30

#消息文件：后跟一个空格和当前播放的文件名
#osd-playing-msg='file：${filename}'

# loop-file = <N | inf | no>，-loop = <N | inf | no>循环单个文件N次。 inf表示永远，不表示正常播放
loop-file=no
# keep-open 会导致 smplayer playlist 在一个视频播放完成后无法自动播放下一个视频(可用于视频结束时间)
#keep-open=yes
# 如果设置为no，则在--keep-open处于活动状态时不会暂停，而只是在文件末尾停止，而在向后搜索时继续向前播放直到结束为止。默认值：是
#keep-open-pause=yes

[mpv-gui]
#player-operation-mode=pseudo-gui
EOF

sed -e "s/^Exec=mpv/#Exec=mpv/g" -i /usr/share/applications/mpv.desktop
sed -e '/#Exec=mpv/a\Exec=mpv --profile=mympv-gui' -i /usr/share/applications/mpv.desktop

# ************************************************************************************************

# 安装gnome图形：
dnf install -y ristretto  shotwell  gnome-screenshot  

# 安装压缩工具
dnf install -y unzip zip file-roller

# PDF工具
dnf install -y evince 

# 编码转换
dnf install -y convmv  


dnf install -y mtr rsync curl cloc
dnf install -y hexedit 
dnf install -y hwinfo lshw gpm 
systemctl enable gpm

dnf install -y gnome-color-manager

dnf install -y screen tmux 

dnf install -y bash-completion bash-doc 

# 安装文本编辑器
dnf install -y pluma pluma-devel mousepad 
# mousepad显示行号
gsettings set org.xfce.mousepad.preferences.view show-line-numbers 'true'

# 配置工具
dnf install -y quota seahorse 

# 显示传感器
dnf install -y python3-keyring curl  hddtemp
chmod u+s /usr/sbin/hddtemp
sh -c "yes|sensors-detect"

# 在现有的图形界面中，还可以以窗口模式运行另外一个X Server，称为nested X Server。最常用的nested X Server是Xephyr
dnf install -y xorg-x11-server-Xephyr

# 字符界面下的文件管理器
dnf install -y mc ranger  

# 字符界面下的一些工具
dnf install -y sox 

dnf install -y gigolo  

dnf install -y vinagre


# 数学工具合集
dnf install -y octave  gnuplot

# 从 DOS 格式转换为 Unix 格式
dnf install -y dos2unix

# 安装minicom
dnf install -y minicom   

# 其他
dnf install -y tree gnome-system-monitor fping mlocate

dnf install -y zsh  

# redshift 根据时间自动地调整屏幕的色温
#dnf install -y redshift redshift-gtk

# 实用程序 gPhoto2 备份手机存储
dnf install -y gphoto2

# 蓝牙(先禁止，需要时再开启服务)
dnf install -y blueman  bluez bluez-devel rfkill

# 安装Flatpak  https://flatpak.org/
dnf install -y flatpak  

# 安装缺少依赖(make menuconfig)
dnf install -y flex bison

# clamav杀毒软件
dnf install -y clamav clamav-devel clamav-update clamd 

# Tealdeer 是 tldr 的一个基于 Rust 的实现
dnf install -y tldr 

# 文本编辑器
dnf install -y vim 

# nvme核心管理工具
dnf install -y nvme-cli

# 安装开源驱动程序包（库）和惠普（HP）系列的打印机(已安装)
dnf install -y gutenprint hplip

# 追踪内核trace-cmd
dnf install -y trace-cmd

# 指纹认证
dnf install -y fprintd  

# 图像处理工具
dnf install -y optipng jpegoptim ImageMagick

# samba相关
dnf install -y samba samba-devel samba-common samba-client
dnf install -y autofs cifs-utils

dnf install -y time strace diffstat  man-pages  asciidoc lsof
dnf install -y scap-security-guide 

dnf install -y tigervnc

# 获取 Linux 系统信息的终端命令
dnf install -y  inxi

# iostat
dnf install -y  sysstat


# 安装nodejs (先不安装,可能出问题,重新登陆后再安装)
dnf install -y  nodejs npm

# -----------------------------------------------------------------------------------------
# 时间服务器
dnf install -y ntp ntpdate
dnf install -y sntp
cat >> /etc/ntp.conf << "EOF"

server cn.pool.ntp.org
server ntp.sjtu.edu.cn 
EOF
#echo "* 18 * * * root  ntpdate  cn.pool.ntp.org" >> /etc/crontab
firewall-cmd --permanent --zone=public --add-service=ntp
systemctl enable ntp

# 解决时间不同步问题
# 如果提示：kod_init_kod_db(): Cannot open KoD db file /var/lib/sntp/kod: No such file or directory
touch /var/lib/sntp/kod
chmod 666 /var/lib/sntp/kod

# 开机校准时间,开机后稍微等几分钟会自动校准
cat >> /etc/profile << "EOF"

# timedatectl set-local-rtc 1
# sntp  cn.ntp.org.cn 
sntp  cn.pool.ntp.org
EOF

# dnf install -y  chrony
# sed 's/pool /#pool /' -i /etc/chrony.conf
# cat >> /etc/chrony.conf << "EOF"
# # 中国 NTP 授时快速服务
# pool cn.ntp.org.cn 
# # 阿里云 NTP
# pool ntp.aliyun.com 
# # 腾讯云 NTP
# pool ntp.tencent.com   
# EOF
#sudo systemctl restart chronyd
#sudo systemctl enable chronyd


# SELinux相关
dnf install -y policycoreutils setools setroubleshoot
# SELinux全部重新标记  sealert 查看
touch /.autorelabel

# -------------------------------------------# 
#             登录管理器
# -------------------------------------------# 
dnf install -y lightdm 
dnf install -y lightdm-gtk lightdm-gtk-greeter lightdm-gobject
dnf install -y lightdm-qt5 lightdm-qt5-devel
#dnf install -y lightdm-kiran-greeter
#dnf install -y lightdm-deepin-greeter

#ln -sf /lib/systemd/system/graphical.taget /etc/systemd/system/default.target
systemctl disable gdm
systemctl enable  lightdm
systemctl set-default graphical.target

# lightdm主题配置
greeterconf="/etc/lightdm/lightdm-gtk-greeter.conf"
[ -f ${greeterconf}.bak ] && cp ${greeterconf}.bak ${greeterconf} || cp ${greeterconf} ${greeterconf}.bak

ln -sf /usr/share/backgrounds/default.jpg /usr/share/backgrounds/lightdm_user_pic.jpg

cat >> /etc/lightdm/lightdm-gtk-greeter.conf << "EOF"
background=/usr/share/backgrounds/lightdm_user_pic.jpg
theme-name=Adwaita
show-indicators=~language;~session;~power
show-clock=true
clock-format=%F %A %T
# 设置 position，这个设置接受 x 和 y 变量，可以使用绝对值(pixels)或相对值(percent). 每个变量都可以增加一个额外的锚定位置 start, center 和 end，数值间用 comma 分隔
position=200,start 50%,center
EOF

# 选择默认桌面xfce4 ,关闭guest登录和用户清单
sed '/#user-session=default/a\user-session=xfce' -i  /etc/lightdm/lightdm.conf
sed 's/#greeter-hide-users=false/greeter-hide-users=true/' -i  /etc/lightdm/lightdm.conf
sed 's/#greeter-allow-guest=true/greeter-allow-guest=false/' -i  /etc/lightdm/lightdm.conf

# 旋转屏幕(永久)登陆后横屏
# 如果是MicroPC或者MiniBook,屏幕默认是竖屏幕,改为横屏,如果是默认是横屏则跳过
# displayMonitor=`xrandr  --output $(xrandr | grep -Ei "\<connected\>" | cut -d " " -f1) --rotate right`
echo ""
echo -e "\e[1;36mIf computer is MicroPC or other MiniBook,Please enter number '1' \e[0m" 
read -p "Enter Number: " display_number
if [ "${display_number}" == "1" ] ;then
  #displayMonitor=`xrandr  --output $(xrandr | grep -Ei "\<connected\>" | cut -d " " -f1) --rotate right`
  #sed "s/#display-setup-script=/display-setup-script=/1" -i  /etc/lightdm/lightdm.conf
  sed "/#display-setup-script=/a\display-setup-script=xrandr  --output DSI-1 --rotate right" -i  /etc/lightdm/lightdm.conf
fi
echo ""


# 设置 dpi (看需要)
echo -e "\e[1;34m===========================================================\e[0m"
# 分辨率 resolution ratio 长 宽  英寸   dpi设置成6或12的倍数(lightdm)

modify_size=96
echo -e "\n\e[1;31mResolution default DPI: ${modify_size}  \e[0m\n"

echo -e "\e[1;32mDo you need to set DPI , if need,please enter number '1'  \e[0m"
echo -e "\e[1;32mdpi set to a multiple of 6 or 12 \e[0m"

read -p "Enter Number: " dpi_number
if [ "${dpi_number}" == "1" ]; then
  read -p "Please enter resolution ratio(Length): " length
  read -p "Please enter resolution ratio(Width):  " width
  read -p "Please enter resolution inch(size):    " size

  resolution_dpi=`echo ${length} ${width} ${size} | awk '{printf("%.2f",sqrt($1^2+$2^2)/$3)}'`
  echo -e "\nResolution DPI : ${resolution_dpi}"

  modify_size=`echo ${resolution_dpi} | awk '{printf("%d",$1-($1%6))}'`
  echo -e "Resolution Modify DPI : ${modify_size} \n"
fi


# # 第1步: fontconfig/xft  /etc/fonts/fonts.conf 或  ~/.fonts.conf
fontconf="/etc/fonts/fonts.conf"
if [ -f "${fontconf}" ] ;then
  cp ${fontconf} ${fontconf}.bak 
cat >> ${fontconf} << EOF
  <!--
    Target dots per inch
  -->
  <match target="pattern">
    <edit name="dpi" mode="assign" >
      <double>${modify_size}</double>
    </edit>
  </match>
EOF
  sed -e '/<\/fontconfig>/d' -i ${fontconf}
  echo "</fontconfig>" >> ${fontconf}

else
  touch ${fontconf}
cat > ${fontconf} << EOF
  <!--
    Target dots per inch
  -->
  <match target="pattern">
    <edit name="dpi" mode="assign" >
      <double>${modify_size}</double>
    </edit>
  </match>
EOF
fi

# 第2步: /etc/X11/Xresources/Xresources 或 ~/.Xresources (不用)
#[ ! -d "/etc/X11/Xresources" ] && mkdir -p /etc/X11/Xresources
#Xresourcesconf="/etc/X11/Xresources/Xresources"
#[ -f "${Xresourcesconf}" ] && cp ${Xresourcesconf} ${Xresourcesconf}.bak || touch ${Xresourcesconf}
#echo "Xft.dpi:${modify_size}" > ${Xresourcesconf}
#xrdb -load  ${Xresourcesconf}
  
# 第3步: 
sed -e "s/#xserver-command=X/xserver-command=X -dpi ${modify_size}/" -i /etc/lightdm/lightdm.conf
sed -e "s/#xft-dpi=/xft-dpi=${modify_size}/" -i /etc/lightdm/lightdm-gtk-greeter.conf

# ------------------------------------------------------------------ #
# systemctl相关配置
# ------------------------------------------------------------------ #
# 显示系统启动时间
#systemd-analyze time
#systemd-analyze critical-chain

# 禁止启动一些服务(需要的时候再开启，视情况而定)
systemctl disable vsftpd 
systemctl disable man-db.timer

# 根分区安装在了 SSD 上，启用 TRIM 会帮助清理 SSD 中的块，从而延长 SSD 的使用寿命
#systemctl enable fstrim.timer
echo -e "\e[1;32mIf your OS install in SSD disk,please enable trim service!\e[0m"
echo "1.enable  trim service [default]"
echo "2.disable trim service "
read -p "choice: " number
case $number in 
    "1")
    systemctl enable fstrim.timer
    ;;
    "2")
    systemctl disable fstrim.timer
    ;;
    *)
    systemctl enable fstrim.timer
    ;;
esac

# ------------------------------------------------------------------ #
# 更换默认桌面 xfce4
update-alternatives --config x-session-manager


# ---------------------------------配置--------------------------------- #


# 禁用自带的 nouveau nvidia驱动 ，防止开机出现黑屏，先在grub引导菜单中添加nomodeset（调用集显）
cat > /etc/modprobe.d/blacklist-nouveau.conf << "EOF" 
blacklist nouveau
options nouveau modeset=0
EOF
# 显卡相关
# 参数:intel_pstate=disable 禁止Sandy Bridge 和 Ivy Bridge 这两个类型的CPU只能被设置成performance或者powersave模式
sed 's/GRUB_CMDLINE_LINUX_DEFAULT/#GRUB_CMDLINE_LINUX_DEFAULT/g' -i /etc/default/grub
echo 'GRUB_CMDLINE_LINUX_DEFAULT="panic=5 quiet acpi_osi=linux intel_pstate=disable"' >> /etc/default/grub

# Grub 引导加载程序 2.06 版本，它的 os-prober 功能默认是禁用的
# 最近的grub上游更新默认禁用了os-prober
# 更新后重启计算机，grub启动菜单将不包含window引导项,可尝试在/etc/default/grub添加
echo 'GRUB_DISABLE_OS_PROBER=false' >> /etc/default/grub
grub2-mkconfig -o /boot/grub2/grub.conf


# sudo 配置
# 将认证模式由su改为sudo,然后修改/etc/sudoers，添加一行：
printf "\n${User_Owner}    ALL=(ALL) ALL" >> /etc/sudoers


bashrc="/root/.bashrc"
[ -f ${bashrc}.bak ] && cp ${bashrc}.bak ${bashrc} || cp ${bashrc} ${bashrc}.bak

cat  >> ${bashrc} << "EOF"
alias rm='rm -i'
alias cp='cp -i'
alias mv='mv -i'

alias ll='ls -l'
alias la='ls -Al'
alias l='ls -CF'

alias dnfse='dnf search'
alias dnfin='dnf install'


alias dfls='df -Th'
alias top1='top -n 1'
alias psall='ps aux'
alias kill9='kill -9'
alias lns='ln -s'
alias duls='du -d 1 -h'
alias dusort='du -d1 -h | sort -k1 -h'
EOF

# 根据实际分区修改(C盘,D盘,E盘,F盘)
# 无法读写ntfs磁盘(突然断电)，先卸载，然后修复(ntfsfix)
cd /mnt && mkdir -p c d e f 

fstab="/etc/fstab"
[ -f ${fstab}.bak ] && cp ${fstab}.bak ${fstab} || cp ${fstab} ${fstab}.bak

cat >> /etc/fstab << "EOF"
#/dev/sdb3  /mnt/c  ntfs  defaults,auto,rw,uid=1000,gid=1000  0 0
#/dev/sdb4  /mnt/d  ntfs  defaults,auto,rw,uid=1000,gid=1000  0 0
#/dev/sda2  /mnt/e  ntfs  defaults,auto,rw,uid=1000,gid=1000  0 0
#/dev/sda3  /mnt/f  ntfs  defaults,auto,rw,uid=1000,gid=1000  0 0
#/dev/sda4  /mnt/g  ntfs  defaults,auto,rw,uid=1000,gid=1000  0 0
#/dev/sda5  /mnt/h  ntfs  defaults,auto,rw,uid=1000,gid=1000  0 0

#UUID=  /mnt/c  ntfs  defaults,auto,rw,uid=1000,gid=1000  0 0
#UUID=  /mnt/d  ntfs  defaults,auto,rw,uid=1000,gid=1000  0 0
#UUID=  /mnt/e  ntfs  defaults,auto,rw,uid=1000,gid=1000  0 0
#UUID=  /mnt/f  ntfs  defaults,auto,rw,uid=1000,gid=1000  0 0
#UUID=  /mnt/g  ntfs  defaults,auto,rw,uid=1000,gid=1000  0 0
#UUID=  /mnt/h  ntfs  defaults,auto,rw,uid=1000,gid=1000  0 0

#/swap/swapfile  swap swap defaults 0 0
EOF

# 更新 USB ID(debian需要手动下载 )
# 数据库文件位于 /var/lib/usbutils 
[ ! -d "/var/lib/usbutils" ] && mkdir -pv /var/lib/usbutils
[ ! -f "/var/lib/usbutils/usb.ids" ] && touch /var/lib/usbutils/usb.ids || cp /var/lib/usbutils/usb.ids  /var/lib/usbutils/usb.ids.old
wget http://www.linux-usb.org/usb.ids -cN -P /var/lib/usbutils
cat > /usr/local/bin/update-usbids << "EOF"
#!/bin/bash
# Update USB ID
wget http://www.linux-usb.org/usb.ids -cN -P /var/lib/usbutils
EOF
chmod 755 /usr/local/bin/update-usbids


# 设置最大监控文件数量，默认值：8192 
# 8192(8M),16384(16M),32768(32M),65536(64M),131072(128M),262144(256M),524288(512M)
# 查看：cat /proc/sys/fs/inotify/max_user_watches    
echo "fs.inotify.max_user_watches=131072" >> /etc/sysctl.conf 


# ------------------------------------------------------------------ #
# 关机时间太长的调查和解决的方法
# ------------------------------------------------------------------ #
# 1.在systemd中启用并激活 journal 日志
# 检查 /etc/systemd/journald.conf 文件的内容，并确保 Storage 的值被设置为自动（auto）或持久（persistent）。
[ ! -d "/var/log/journal" ] &&  mkdir -p /var/log/journal
journaldconf="/etc/systemd/journald.conf"
[ -f ${journaldconf}.bak ] && cp ${journaldconf}.bak ${journaldconf} || cp ${journaldconf} ${journaldconf}.bak
sed 's|#Storage=auto|Storage=auto|g' -i /etc/systemd/journald.conf

# 2.通过减少默认停止超时来加快 Linux 中的关机速度（快速修复）
systemconf="/etc/systemd/system.conf"
[ -f ${systemconf}.bak ] && cp ${systemconf}.bak ${systemconf} || cp ${systemconf} ${systemconf}.bak
sed 's|#DefaultTimeoutStopSec=90s|DefaultTimeoutStopSec=10s|g' -i /etc/systemd/system.conf

# 3.看门狗的模块(可选)
# 检查看门狗是否在运行：ps -af | grep watch*
# 修改配置文件 /etc/systemd/system.conf 中将 ShutdownWatchdogSec 的值从 10 分钟改为更低的值
#sed 's|#ShutdownWatchdogSec=10min|ShutdownWatchdogSec=1min|g' -i /etc/systemd/system.conf

# ------------------------------------------------------------------ #
# 中文化
#localectl  set-locale LANG=zh_CN.UTF8
#echo "LANG="zh_CN.UTF-8"" > /etc/locale.conf
echo "export LANG=zh_CN.UTF-8" >> /etc/profile
ln -sf /usr/share/zoneinfo/Asia/Shanghai /etc/localtime

# ------------------------------------------------------------------ #
# grub引导win10 
# ------------------------------------------------------------------ #
custom="/etc/grub.d/40_custom"
[ -f ${custom}.bak ] && cp ${custom}.bak ${custom} || cp ${custom} ${systemconf}.bak

cat > /etc/grub.d/40_custom << "EOF"
#!/bin/sh
exec tail -n +3 $0

## 如果没有win10,可以反注释试试
#menuentry "win10" {
#insmod part_gpt
#insmod fat
## windows EFI位置
#set root='hd1,gpt1' 
#chainloader /EFI/Microsoft/Boot/bootmgfw.efi
#}
EOF

grub2-mkconfig -o /boot/grub2/grub.cfg


# ------------------------------------------
# 清理工作
mv -f /etc/yum.repos.d/openEuler_cdrom.repo /etc/yum.repos.d/openEuler_cdrom.repo.bak
umount /media/cdrom 

# 删除一个默认用户openeuler
# 或者 userdel openeuler && rm -rf /home/openeuler
oeuser=`cat /etc/passwd | grep -i openeuler`
if [ ! -z "${oeuser}" ] ;then
   userdel -r openeuler
   echo -e "\e[1;32mopeneuler user is deleted ! \e[0m"
else
   echo -e "\e[1;32mNo openeuler users ! \e[0m"
fi 


# 版本升级
# dnf distro-sync --allowerasing
# 尝试添加'--skip-broken'以跳过可卸载的软件包，或者添加'--nobest'以不仅使用最佳候选软件包,参数'--skip-broken'可以省略
# dnf upgrade -y --allowerasing --skip-broken --nobest 


# ------------------------------------------------------------------ #
# xfce4设置(重启后进入桌面后执行)
# 如果设置DPI后,需要重启后执行 xfce4set.sh 程序
echo -e "\n\e[1;32mNote: If you set the DPI, you will need to reboot and run the [xfce4set.sh] program. \e[0m"
cat > ${HOME}/xfce4set.sh << "EOF"
modify_size1=`cat /etc/lightdm/lightdm.conf | grep xserver-command=X | cut -d " " -f3`
xfconf-query -c xsettings -p /Xft/DPI -n -t int -s "${modify_size1}"
xfconf-query -c xsettings -p /Gtk/FontName -n -t string -s "Sans 6"
xfconf-query -c xsettings -p /Gtk/MonospaceFontName -n -t string -s "Monospace 6"
xfconf-query -c xfwm4     -p /general/title_font -n -t string -s "Sans Bold 6"

xfconf-query -c xsettings -p /Net/IconThemeName -n -t string -s "Adwaita"
xfconf-query -c xsettings -p /Net/ThemeName -n -t string -s "Adwaita"

# 合上笔记本时,关闭屏幕显示
xfconf-query -c xfce4-power-manager -p /xfce4-power-manager/lid-action-on-ac -n -t int -s "0"
xfconf-query -c xfce4-power-manager -p /xfce4-power-manager/lid-action-on-battery -n -t int -s "0"
xfconf-query -c xfce4-power-manager -p /xfce4-power-manager/show-tray-icon -s "true"
EOF
chmod +x xfce4set.sh


#------------------------------------------------------------------------------------------------------#
#                                        计算耗时
#------------------------------------------------------------------------------------------------------#

# 等同于 date +"%F %T"
secondtime=`date +"%Y-%m-%d %H:%M:%S"`

# 计算时间差
time_difference(){
	# 时间格式必须为 date +"%Y-%m-%d %H:%M:%S" ，即date +"%F %T"
	first="$1"
	second="$2"

	seconds_all=$(expr $(date +%s -d "${second}") - $(date +%s -d "${first}")) 
	hour=$(expr ${seconds_all} / 3600) 

	hour_remaining=$(expr ${seconds_all} % 3600) 
	min=$(expr ${hour_remaining}  / 60) 
	sec=$(expr ${hour_remaining}  % 60) 
	echo "Run-Times: ${hour} hour ${min} min ${sec} sec "  
};

echo " "
echo "#########################################################"
echo "FirstTime: ${firsttime} " 
echo "EndTime: ${secondtime} "
time_difference "${firsttime}"  "${secondtime}" ;
echo "#########################################################"


